<?php
/*
The script to convert the Favorites records to the Watching/Subscriptions records.
At first, try to run in in two modes, setting $deleteInactive=TRUE; and $replicateFavorites=TRUE;
This would delete any Favorites available for inactive (disabled users), and will put all Favorites in the Subscriptions database.
Then put FALSE for both, and set $duplicatesAndCodes=TRUE;
This would delete all possible duplicates from Subscriptions, and will assign the subscription codes to those records came from Favorites.

For miniBB version 3.5 and higher.

This file is part of miniBB. miniBB is free discussion forums/message board software, supplied with no warranties.
Check COPYING file for more details.
Copyright (C) 2021 Paul Puzyrev. www.minibb.com
Latest File Update: 2021-03-16
*/

define ('INCLUDED776',1);

include('./setup_options.php');
include($pathToFiles.'setup_'.$DB.'.php');

$favoritesTb='minibbtable_favorites';

$deleteInactive=FALSE;
$replicateFavorites=FALSE;
$duplicatesAndCodes=TRUE;

/* Should include Active members only. Favorites for inactive Members are removed with no trace. */

#delete from favorites where user_id in (select user_id from users where activity=0);

if($deleteInactive) mysqli_query($mysqlink, "delete from {$favoritesTb} where user_id in (select {$dbUserId} from {$Tu} where {$dbUserAct}=0)");

#insert send_mails (user_id, topic_id, active) select user_id, topic_id, 1 from favorites;

if($replicateFavorites) mysqli_query($mysqlink, "insert {$Ts} (user_id, topic_id, active) select user_id, topic_id, 1 from {$favoritesTb}");

/* Remove possible duplicates and assign Subscription codes */

if($duplicatesAndCodes){

$delRecords=array();
$assignedCodes=0;

if($row=db_simpleSelect(0, $Ts, 'id, user_id, topic_id, email_code', '', '', '', 'user_id asc, id asc')){

$prevUser=0;
$prevTopic=0;
$prevId=0;

do{

if($row[1]==$prevUser and $row[2]==$prevTopic){
$delRecords[]=$row[0];
}

if((string)$row[3]==''){
$email_code=substr(preg_replace("#[^0-9A-Za-z]+#", "A", md5(uniqid(rand()))),0,10);
updateArray(array('email_code'), $Ts, 'user_id', $row[1], 'topic_id', $row[2]);
$assignedCodes++;
}

$prevId=$row[0];
$prevUser=$row[1];
$prevTopic=$row[2];
}
while($row=db_simpleSelect(1));
}

if(sizeof($delRecords)>0){

foreach($delRecords as $dl){
db_delete($Ts, 'id', '=', $dl);
}

}

echo 'Found and deleted duplicates: '.(sizeof($delRecords)).$brtag;

echo 'New subscription codes assigned: '.$assignedCodes;

}


?>